/*************************************************************************
    fsadm - File system administrator
    1.00 85-09-16 Henrik Norbeck, Luxor Datorer AB
   
    draw.c inneh}ller utskriftsrutiner f|r grafik m m.
*************************************************************************/

#include <stdio.h>
#include "fsadm.h"
#include "struct.h"

#define MOVE(x, y) bufp += sprintf(bufp, "\033:%d;%dm", x, y)
#define LINE(x, y) bufp += sprintf(bufp, "\033:%d;%d;;1d", x, y)
#define FILL(x, y, patt) bufp += sprintf(bufp, "\033:%d;%d;%df", x, y, patt)
#define COPY(sx, sy, dx, dy, w, h, op) bufp += sprintf(bufp,\
	"\033:%d;%d;%d;%d;%d;%d;%dr", sx, sy, dx, dy, w, h, op)
#define Printcur(r, k, string) bufp += sprintf(bufp, "%s%s", tgoto(cm, k, r),\
	string);

/* Meddelanden */
extern int n_lang;
extern char *portheader[];
extern int lang;

/* Terminalparametrar: */
extern int term;  /* Terminaltyp */
extern int term_w;/* Terminalbredd */
extern int term_h;/* Terminalh|jd */
extern char *cm;  /* Flytta mark|r */
extern char *clr; /* T|m sk{rmen */
extern char *so;  /* Standout */
extern char *se;  /* Slut p} standout */
extern int fontw; /* Fontens storlek */
extern int fonth;

extern char cwd[];

extern int ncommands, nfunctions;
extern struct click_box fikon[], kikon[];

extern struct viewport port[];

extern int port_h;
extern int p_port_h, p_port_w;

extern short cbox_x, cbox_y, fbox_x, fbox_y;

static char grbuf[2048];
static int grsiz;

/*** Tillverka grafik och dylikt ***/
mkports()
{
    register char *bufp;
    register int i;
    register int y, px, py, ph, pw;/* I pixlar */
    register int p2x, p2y, p3x, p3y;

    bufp = grbuf;
    bufp += sprintf(bufp, "%s", clr);

    /* draw lines, arrows etc */
    if (term == WINDOW) {
	/* draw line under directory name */
	y = fonth * (term_h - 1) - 1;
	MOVE(0, y);
	LINE(fontw * term_w - 1, y);

	/* draw port box */
	port[FILES].px = px = fontw * port[FILES].x;
	py = fonth * (term_h - port[FILES].y - 1);
	p_port_h = ph = fonth * port_h;
	p_port_w = pw = fontw * PORT_W;
	MOVE(px-2, py-2);
	LINE(px+pw+21, py-2);
	LINE(px+pw+21, py+ph+fonth);
	LINE(px-2, py+ph+fonth);
	LINE(px-2, py-2);
	MOVE(px+pw+2, py+ph);
	LINE(px+pw+2, py-2);
	MOVE(px+pw+2, py+24);
	LINE(px+pw+21, py+24);
	MOVE(px+pw+2, py+ph-26);
	LINE(px+pw+21, py+ph-26);

	/* draw down arrow */
	MOVE(px+pw+14, py+18);
	LINE(px+pw+14, py+9);
	LINE(px+pw+18, py+9);
	LINE(px+pw+12, py+3);
	LINE(px+pw+6, py+9);
	LINE(px+pw+10, py+9);
	LINE(px+pw+10, py+18);
	LINE(px+pw+14, py+18);

	/* draw up arrow */
	MOVE(px+pw+10, py+ph-20);
	LINE(px+pw+10, py+ph-11);
	LINE(px+pw+6, py+ph-11);
	LINE(px+pw+12, py+ph-5);
	LINE(px+pw+18, py+ph-11);
	LINE(px+pw+14, py+ph-11);
	LINE(px+pw+14, py+ph-20);
	LINE(px+pw+10, py+ph-20);

	/* fill header */
	MOVE(px-1, py+ph+fonth-1);
	FILL(px+pw+20, py+ph+1, 1);

	/* copy port */
	port[DIRS].px = p2x = fontw * port[DIRS].x;
	port[POOL].px = p3x = fontw * port[POOL].x;
	for (i = 0; i < 3; i++)
	    port[i].py = py;
	p3y = p2y = py;
	COPY(px-2, py-2, p2x-2, p2y-2, pw+24, ph+fonth+3, 0);
	COPY(px-2, py-2, p3x-2, p3y-2, pw+24, ph+fonth+3, 0);

	/* port headers */
	for (i = 0; i<3; i++)
	    Printcur(2, port[i].x+
		(PORT_W+2-strlen(portheader[i * n_lang+lang]))/2,
		portheader[i * n_lang+lang]);

	/* lines under port headers */
	MOVE(px-2, py+ph);
	LINE(px+pw+21, py+ph);
	MOVE(p2x-2, p2y+ph);
	LINE(p2x+pw+21, p2y+ph);
	MOVE(p3x-2, p3y+ph);
	LINE(p3x+pw+21, p3y+ph);

	/* click boxes */
	px = fontw * fbox_x - 8;
	py = fonth * (term_h - fbox_y - 1) - 2;
	pw = fontw * BOXW + 16;
	ph = fonth * BOXH + 4;
	p2x = fontw * cbox_x - 8;
	p2y = fonth * (term_h - cbox_y - 1) - 2;
	MOVE(px, py);
	LINE(px+pw, py);
	LINE(px+pw, py+ph);
	LINE(px, py+ph);
	LINE(px, py);
	for (i = 1; i < nfunctions; i++)
	    COPY(px, py, px, py - i * fonth * (BOXD+BOXH), pw+1, ph+1, 0);
	for (i = 0; i < ncommands; i++)
	    COPY(px, py, p2x, p2y + i * fonth * (BOXD+BOXH), pw+1, ph+1, 0);
	}
    else {
	/* Draw line under directory name */
	Printcur(1, 0, "");
	for (i = 0; i<term_w; i++)
	    bufp[i] = '-';
	bufp += i;

	/* Print port header and arrows */
	for (i = 0; i<3; i++) {
	    Printcur(2, port[i].x, portheader[i * n_lang+lang]);
	    Printcur(3, port[i].x, "<");
	    Printcur(port[i].y+1, port[i].x, ">");
	    }
	}
    /* Print texts */
    for (i = 0; i < nfunctions; i++)
	Printcur(fbox_y + i * (BOXD+BOXH), fbox_x, fikon[i].txt);
    for (i = 0; i < ncommands; i++)
	Printcur(cbox_y - i * (BOXD+BOXH), cbox_x, kikon[i].txt);
    Printcur(3, fbox_x, "FSADM");
    Printcur(5, fbox_x, " Ver");
    Printcur(6, fbox_x, " 2.0");

    grsiz = bufp-grbuf;
    /* *** trace size of grbuf *** */
    printf("%d/%d", grsiz, sizeof(grbuf));
    getchar();
}

/*** Skriv om allt p} sk{rmen ***/
draw()
{
    refresh(OFF);
    write(STDOUT, grbuf, grsiz);
    pr_info();
    pr_mode();
    refresh(ON);
}

/*** Skriv ut den information som {ndras ***/
pr_info()
{
    register int i;
    char format[10];

    sprintf(format, "%%s%%-%ds", term_w);
    printf(format, tgoto(cm, 0, 0), cwd);
    for (i = 0; i < 3; i++)
	pr_port(i);
}
