/***********************************************************
getcwd() gets the current working directory. Function is
here because it doesn't exist in the standard c library!
***********************************************************/

#include <stdio.h>
#include <sys/types.h>
#include <sys/dir.h>
#include <fcntl.h>
#define ERROR	(-1)
#define TRUE	1

getcwd(d_name, maxlen)
register char *d_name;
register int maxlen;
{
    char *strrchr();
    register int fd;
    register struct direct dirbuf, udirbuf;
    register ino_t inode;
    register char *p;
    char pbuf[256], dbuf[256];

    if ((fd = open(".", O_RDONLY)) == ERROR)
	goto error;
    read(fd, (char *) &dirbuf, sizeof(dirbuf));
    inode = dirbuf.d_ino;
    close(fd);
    strcpy(pbuf, "..");
    *dbuf = '\0';
    while (TRUE) {
	if ((fd = open(pbuf, O_RDONLY)) == ERROR)
	    goto error;
	read(fd, (char *) &dirbuf, sizeof(dirbuf));
	if (dirbuf.d_ino == inode)
	    break;
	do {
	    read(fd, (char *) &udirbuf, sizeof(udirbuf));
	    } while (inode != udirbuf.d_ino);
	close(fd);
	strcat(pbuf, "/..");
	inode = dirbuf.d_ino;
	strcat(dbuf, "/");
	strncat(dbuf, udirbuf.d_name, DIRSIZ);
	}
    if (*dbuf == '\0')
	strcpy(dbuf, "/");

    /* Turn the name around */
    *d_name = '\0';
    do {
	p = strrchr(dbuf, '/');
	strcat(d_name, p);
	*p = '\0';
	} while (p != dbuf);
    return (strlen(d_name));
error:
    *d_name = '\0';
    return (0);
}
