/*************************************************************************
    fsadm - File system administrator
    1.00 85-09-16 Henrik Norbeck, Luxor Datorer AB
   
    icon.c inneh}ller funktioner f|r att s{tta upp ikoner
*************************************************************************/

#include <stdio.h>
#include <win/w_macros.h>
#include "fsadm.h"
#include "struct.h"

/* Terminalparametrar: */
extern int term;  	/* Terminaltyp */
extern int term_w;      /* Terminalbredd */
extern int term_h;      /* Terminalh|jd */
extern int fontw; 	/* Fontens storlek */
extern int fonth;

extern short fbox_x, fbox_y, cbox_x, cbox_y;
extern int port_h;
extern int p_port_h, p_port_w;

extern struct viewport port[];

extern int ncommands, nfunctions;

static struct icon_info {
    struct icon_info *next;
    int fd;
    pix_d x, y, w, h;
    char s[10];
    word f;
    } *icon_list;

/*** Skapar listan med ikoner f|r portarna och klickboxarna ***/
initicons()
{
    register int pt, i, x, y, w, h;
    char seq[10];

    /* S{tt upp portarnas ikoner */
    for (pt = 0; pt < 3; pt++) {
	x = port[pt].x + 1; y = port[pt].y - port_h + 2;
	/* S{tt upp filnamnens ikoner */
	for (i = 0; i < port_h; i++) {
	    sprintf(seq, "\033P%d,%d.", pt, i);
	    i_icon(x, y + i, PORT_W, 1, seq, I_TEXT | I_INVERT);
	    }

	/* S{tt upp pilarnas ikoner */
	sprintf(seq, "\033A%d,0.", pt);
	x = port[pt].px; y = port[pt].py;
	i_icon(x + p_port_w + 3, y + p_port_h - 25, 18, 25, seq,
			I_INVERT);
	sprintf(seq, "\033A%d,1.", pt);
	i_icon(x + p_port_w + 3, y - 1, 18, 25, seq, I_INVERT);

	/* S{tt upp ikonen f|r porthuvudet */
	sprintf(seq, "\033S%d.", pt);
	i_icon(x - 1, y + p_port_h + 1, p_port_w + 22, fonth - 1, seq,
			I_INVERT);

	/* S{tt upp ikonen f|r hela porten */
	sprintf(seq, "\033X%d.", pt);
	i_icon(x + p_port_w + 3, y + 25, 18, p_port_h - 50, seq,
			I_INVERT);
	}

    /* S{tt upp funktionsboxarnas ikoner */
    x = fontw * fbox_x - 7;
    y = fonth * (term_h - fbox_y - 1) - 1;
    w = fontw * BOXW + 15;
    h = fonth * BOXH + 3;
    for (i = 0; i < nfunctions; i++) {
	sprintf(seq, "\033F%d.", i);
	i_icon(x, y - i * fonth * (BOXD + BOXH), w, h, seq, I_INVERT);
	}
    x = fontw * cbox_x - 7;
    y = fonth * (term_h - cbox_y - 1) - 1;
    for (i = 0; i < ncommands; i++) {
	sprintf(seq, "\033C%d.", i);
	i_icon(x, y + i * fonth * (BOXD + BOXH), w, h, seq, I_INVERT);
	}
    mkicons();
}

/*** Lagra en ikon i ikonlistan ***/
static i_icon(x, y, w, h, s, f)
pix_d x, y, w, h;
char *s;
word f;
{
    char *alloc();
    register struct icon_info *ip;

    ip = (struct icon_info *) alloc(sizeof(struct icon_info));
    ip->x = x;
    ip->y = y;
    ip->w = w;
    ip->h = h;
    strcpy(ip->s, s);
    ip->f = f;
    ip->next = icon_list;
    icon_list = ip;
}

/*** S{tt upp ikonerna f|r portarna och kommandoboxarna ***/
mkicons()
{
    register struct icon_info *ip;

    for (ip = icon_list; ip; ip = ip->next)
	wd_icon(STDIN, ip->x, ip->y, ip->w, ip->h, ip->s, ip->f);
}

/*** Skapa en ikon vid x,y p} fil fd, med bredd w, h|jd h,
   s{ndsekvens s och flaggor f ***/
wd_icon(fd, x, y, w, h, s, f)
int fd;
pix_d x, y, w, h;
char *s;
word f;
{
    struct winicon ic;

    ic.ip_xorig=ic.il_xorig=x;
    ic.ip_yorig=ic.il_yorig=y;
    ic.ip_xsize=ic.il_xsize=w;
    ic.ip_ysize=ic.il_ysize=h;
    strcpy(ic.i_cmdseq, s);
    ic.i_flags=I_PMODE | I_LMODE | I_PRESS | I_LZERO | f;
    Winicon(fd, &ic);
    if (ic.i_rstat != W_OK)
	error(NO_ICON);
}
