/*************************************************************************
    fsadm - File system administrator
    1.00 85-09-16 Henrik Norbeck, Luxor Datorer AB
   
    menu.c inneh}ller rutiner f|r ikon- och menyval.
*************************************************************************/

#include <stdio.h>
#include <win/w_macros.h>
#include "fsadm.h"
#include "struct.h"

/* Terminalparametrar: */
extern int term;  	/* Terminaltyp */
extern int term_w;      /* Terminalbredd */
extern int term_h;      /* Terminalh|jd */
extern char *cm;
extern char *ku;        /* S{nds av upp}tpilen p} terminalen */
extern char *kd;        /* S{nds av ned}tpilen p} terminalen */
extern char *kl;	/* S{nds av v{nsterpilen p} terminalen */
extern char *kr;	/* S{nds av h|gerpilen p} terminalen */
extern int fonth;
extern int fontw;

extern char cwd[];

extern short fbox_x, fbox_y, cbox_x, cbox_y;
extern int port_h;

extern struct viewport port[];

extern struct click_box kikon[];

extern struct click_box fikon[];

static int mode = 0;

/*** Huvudkommandoloopen ***/
scan()
{
    register int n, pt;

    while (1) {
	printf("%s", tgoto(cm, strlen(cwd), 0));
	if (getchar() == ESC)
	    switch (getchar()) {
		case 'P':	/* Ett filnamn i en port */
		    pt = getnum();
		    n = getnum();
		    if (mode  AND  pt == DIRS)
			cd(pt, n);
		    else
			mark(pt, n);
		    break;
		case 'A':	/* En av scroll-pilarna */
		    pt = getnum();
		    n = getnum();
		    scroll(pt, n);
		    break;
		case 'S':	/* Porthuvudet */
		    pt = getnum();
		    do_status(pt);
		    break;
		case 'X':	/* Alla filer i porten */
		    pt = getnum();
		    mark(pt, ALL);
		    break;
		case 'F':
		    n = getnum();
		    fikon[n].func(n);
		    break;
		case 'C':
		    if (kikon[n = getnum()].chk)
			if (port[POOL].cnt == 0)
			    break;
		    kikon[n].func();
		    break;
		default:
		    BELL;
		    break;
		}
	else
	    BELL;
	}
}

/*** L{s ett tal fr}n terminalen ***/
getnum()
{
    register int n;
    register char c;

    n = 0;
    while ((c = getchar()) >= '0' AND c <= '9')
	n = n * 10 + c - '0';
    return (n);
}

/*** L{s ett tecken och omvandla till stora bokst{ver ***/
getupper()
{
    register char c;

    return ((c = getchar()) < '`' OR c > '~' ? c : c - 'a' + 'A');
}

/*** V{nta p} y/n eller j/n fr}n tangentbordet ***/
yes_no()
{
    while (1)
	switch (getchar()) {
	case 'n':
	case 'N':
	    return (NO);
	case 'y':
	case 'Y':
	case 'j':
	case 'J':
	    return (YES);
	}
}

static int curr_func = 0;

/*** S{tt chdir-mod ***/
set_chdir(n)
register int n;
{
    set_mode(1, n);
}

/*** S{tt mark-mod ***/
set_mark(n)
register int n;
{
    set_mode(0, n);
}

/*** S{tt vilken mod vi skall befinna oss i ***/
set_mode(n, func)
register int n;
{
    if (mode != n) {
	pr_mode();
	mode = NOT mode;
	curr_func = func;
	pr_mode();
	}
}

/*** Invertera ramen runt den mod vi befinner oss i ***/
pr_mode()
{
    register int x, y, w, h;

    if (term == WINDOW) {
	x = fontw * fbox_x - 10;
	y = fonth * (term_h - fbox_y - 1 - curr_func * (BOXH+BOXD)) - 4;
	w = fontw * BOXW + 20;
	h = fonth * BOXH + 8;
	printf("\033:%d;%dm", x, y);
	printf("\033:%d;%di", x, y+h);
	printf("\033:%d;%di", x+w, y+h);
	printf("\033:%d;%di", x+w, y);
	printf("\033:%d;%di", x, y);
	}
}
