/*************************************************************************
    fsadm - File system administrator
    1.00 85-09-16 Henrik Norbeck, Luxor Datorer AB
   
    message.c inneh}ller utskriftsrutiner f|r meddelanden
*************************************************************************/

#include <stdio.h>
#include <fcntl.h>
#include <win/w_macros.h>
#include "fsadm.h"

/* Meddelanden */
extern int n_lang;
extern int lang;
extern char *messages[];

/* Terminalparametrar: */
extern int term;  /* Terminaltyp */
extern int term_w;/* Terminalbredd */
extern int term_h;/* Terminalh|jd */
extern char *cm;  /* Flytta mark|r */
extern int fontw; /* Fontens storlek */
extern int fonth;

/*** Skriv ett meddelande i en ram ***/
message(n, str)
register int n;
char *str;
{
    register int len, x, y;
    register char *msg;

    if (term == WINDOW) {
	Rmicons(STDIN);
	refresh(OFF);
	}
    msg = messages[n * n_lang + lang];
    len = strlen(msg);
    if (str)
	len += strlen(str);
    x = (term_w - len) / 2;
    y = (term_h - 2) / 2;
    frame(x, y, len, 2);
    printf("%s", tgoto(cm, x, y));
    printf(msg, str);
    msg = messages[HIT_CE * n_lang + lang];
    printf("%s%s", tgoto(cm, x, y + 1), msg);
    while (getchar() != CE)
	;
    if (term == WINDOW) {
	mkicons();
	refresh(ON);
	}
    draw();
}

/*** Skriv ett meddelande p} terminalen ***/
text(n, str)
register int n;
register char *str;
{
    printf(messages[n * n_lang + lang], str);
}

/*** Skriv ett meddelande i en ram och fr}ga efter en str{ng ***/
ask(n, str, res, res_len)
register int n, res_len;
register char *str, *res;
{
    register int len, x, y, i;
    register char c;
    register char *msg;

    if (term == WINDOW) {
	Rmicons(STDIN);
	refresh(OFF);
	}
    msg = messages[n * n_lang + lang];
    len = strlen(msg) + res_len;
    if (str)
	len += strlen(str);
    x = (term_w - len) / 2;
    y = (term_h - 2) / 2;
    frame(x, y, len, 1);
    printf("%s", tgoto(cm, x, y));
    printf(msg, str);
    i = 0;
    while ((c = getchar()) != '\n')
	switch (c) {
	    case BS:
		if (i) {
		    i--;
		    printf("\b \b");
		    }
		break;
	    case CE:
		for (; i; i--)
		    printf("\b \b");
		break;
	    case DEL:
		break;
	    default:
		if (i < res_len AND c > ' ') {
		    res[i++] = c;
		    putchar(c);
		    }
		break;
	    }
    res[i] = '\0';
    if (term == WINDOW) {
	mkicons();
	refresh(ON);
	}
    draw();
}

/*** S{tt upp en ram vid (x, y) med storlek (w, h) ***/
frame(x, y, w, h)
register int x, y, w, h;
{
    register int i;
    register char line = (term == WINDOW ? ' ' : '-');
    char format[10];

    /* Skriv blanka */
    sprintf(format, "%%s%%%ds", w + 2);
    for (i = 0; i < h; i++)
	printf(format, tgoto(cm, x - 1, y + i), "");
    /* Skriv |vre raden */
    printf("%s", tgoto(cm, x - 1, y - 1));
    for (i = 0; i < w + 2; i++)
	putchar(line);
    /* Skriv undre raden */
    printf("%s", tgoto(cm, x - 1, y + h));
    for (i = 0; i < w + 2; i++)
	putchar(line);
    if (term == WINDOW) {
	/* Rita ram */
	printf("\033:%d;%dm", (x - 1) * fontw + 1,
					(term_h - y + 1) * fonth - 1);
	printf("\033:%d;%d;;1d", (x + w + 1) * fontw - 1,
					(term_h - y + 1) * fonth - 1);
	printf("\033:%d;%d;;1d", (x + w + 1) * fontw - 1,
					(term_h - y - 1 - h) * fonth + 1);
	printf("\033:%d;%d;;1d", (x - 1) * fontw + 1,
					(term_h - y - 1 - h) * fonth + 1);
	printf("\033:%d;%d;;1d", (x - 1) * fontw + 1,
					(term_h - y + 1) * fonth - 1);
	}
}

/*mkwin(x, y, w, h)
register int x, y, w, h;
{
    struct winstruc wd;
    register int wfd;

    / * Get data of original window, so that we set this window up 
       relative to it * /
    Winstat(STDIN, &wd);
    if ((wfd = open("/win", O_RDWR)) == ERROR)
	return(ERROR);
    wd.wp_xorig = wd.wl_xorig += x;
    wd.wp_yorig = wd.wl_yorig += y;
    wd.wp_xsize = wd.wl_xsize = w;
    wd.wp_ysize = wd.wl_ysize = h;
    wd.wp_vxorig = wd.wl_vxorig = 0;
    wd.wp_vyorig = wd.wl_vyorig = 0;
    wd.wp_vxsize = wd.wl_vxsize = w;
    wd.wp_vysize = wd.wl_vysize = h;
    wd.w_border = SLBORDER;
    wd.w_level = 0;
    wd.w_tsig = wd.w_ntsig = wd.w_rsig = wd.w_csig = 0;
    wd.w_flags |= LOCK;
    Wincreat(wfd, &wd);
    if (wd.w_rstat != W_OK)
	return(ERROR);
    sterm(wfd, RAW);
    return(wfd);
}*/
