/*************************************************************************
    fsadm - File system administrator
    1.00 85-09-16 Henrik Norbeck, Luxor Datorer AB
   
    pager.c inneh}ller more-funktionerna
*************************************************************************/

#include <stdio.h>
#include <sys/types.h>
#include <sys/dir.h>
#include <sys/stat.h>
#include <a.out.h>
#include "fsadm.h"
#include "struct.h"

extern char *messages[];

extern int term_h, term_w;
extern char *clr, *so, *se;

/*** G|r more p} en fil ***/
more_file(fd, path)
register int fd;
register char *path;
{
    register int i, bin_flag;
    struct xexec xbuf;

    for (i = strlen(path) + 2; i; i--)
	putchar(':');
    printf("\n%s\n", path);
    for (i = strlen(path) + 2; i; i--)
	putchar(':');
    putchar('\n');
    i = read(fd, (char *) &xbuf, sizeof(xbuf));
    lseek(fd, 0, 0);
    bin_flag = (i == sizeof(xbuf) AND xbuf.x_magic == X_MAGIC);
    for (i--; i>=0; i--)
	if ( ((char *) &xbuf)[i] > 127 )
	    bin_flag = TRUE;
    if (bin_flag) {
	text(NOT_TEXT, path);
	if (yes_no()) {
	    pr_char('\n');
	    i = more_bin(fd, path);
	    }
	else
	    i = 0;
	}
    else
	i = more_text(fd, path);
    close(fd);
    return (i);
}

/*** G|r more p} en textfil ***/
more_text(fd, path)
register int fd;
char *path;
{
    register int c;
    register int n=0, i=0, line=1;

    while ((c = read_char(fd)) != ERROR) {
	pr_char(c);
	if (c == '\n') {
	    n++;
	    line++;
	    i = 0;
	    }
	else {
	    if (c == TAB)
		i += 8 - i % 8;
	    else
		i++;
	    if (i % term_w == 0)
		n++;
	    }
	if (n == term_h - 3) {
	    dump();
	    if ((n = more(MORE, NULL, n, path, line)) == QUIT OR n == NEXT) {
		flush();
		return (n);
		}
	    else if (n == BINARY) {
		flush();
		lseek(fd, 0, 0);
		return(more_bin(fd, path));
		}
	    }
	}
    dump();
    flush();
    return (FALSE);
}

/*** G|r more (dvs ett slags od) p} en bin{r fil ***/
more_bin(fd, path)
register int fd;
char *path;
{
    register int c;
    register int n=0, i=0, ncol = term_w / 5;

    while ((c = read_char(fd)) != ERROR) {
	if (c < 32 OR c > 126) {
	    /* Control character */
	    pr_char('\\');
	    switch (c) {
		case '\n':
		    pr_str("n   ", 4);
		    break;
		case '\t':
		    pr_str("t   ", 4);
		    break;
		case '\033':
		    pr_str("e   ", 4);
		    break;
		case '\b':
		    pr_str("b   ", 4);
		    break;
		case '\r':
		    pr_str("r   ", 4);
		    break;
		case '\f':
		    pr_str("f   ", 4);
		    break;
		default:
		    pr_char((c >> 6) + '0');
		    pr_char(((c >> 3) & 7) + '0');
		    pr_char((c & 7) + '0');
		    pr_char(' ');
		    break;
		}
	    }
	else {
	    pr_char(c);
	    pr_str("    ", 4);
	    }
	if (++i == ncol) {
	    pr_char('\n');
	    i = 0;
	    if (++n == term_h - 3) {
		dump();
		if ((n = more(MORE, NULL, n, path, 0)) < 0) {
		    flush();
		    return(n);
		    }
		}
	    }
	}
    dump();
    flush();
    return (FALSE);
}

/*** G|r more (dvs lc) p} ett bibliotek ***/
more_dir(fd, path)
register int fd;
register char *path;
{
    char *alloc();
    register int n, j, ncol = term_w / 16, cnt = 0, lines;
    struct direct dirbuf;
    register struct file_info *filelist=NULL, *filep, *prevp;

    for (n = j = strlen(path) + 2 + strlen(messages[DIRECTORY]); j; j--)
	putchar(':');
    text(DIRECTORY, path);
    for (j = n; j; j--)
	putchar(':');
    n = 0;
    /* L{s biblioteket och sortera det */
    while (read_str(fd, (char *) &dirbuf, sizeof(dirbuf)) == sizeof(dirbuf)) {
	if (dirbuf.d_ino == 0)
	    continue;
	prevp = NULL;
	for (filep = filelist; filep; filep = filep->next) {
	    if (strncmp(filep->name, dirbuf.d_name, DIRSIZ) > 0)
		break;
	    prevp = filep;
	    }
	if (prevp) {
	    filep = (struct file_info *) alloc(sizeof(struct file_info));
	    filep->next = prevp->next;
	    prevp->next = filep;
	    }
	else {
	    filep = (struct file_info *) alloc(sizeof(struct file_info));
	    filep->next = filelist;
	    filelist = filep;
	    }
	filep->name = alloc(16);
	strncpy(filep->name, dirbuf.d_name, DIRSIZ);
	for (j = 0; filep->name[j] AND j < DIRSIZ; j++)
	    ;
	for (; j < 16; j++)
	    filep->name[j] = ' ';
	cnt++;
	}
    /* Ber{kna antalet rader utskriften tar */
    cnt = (cnt - 1) / ncol +1;
    /* Skriv ut det */
    lines = 0;
    for (prevp = filelist; prevp AND lines < cnt; prevp = prevp->next) {
	filep = prevp;
	while (filep) {
	    pr_str(filep->name, sizeof(dirbuf));
	    for (j = 0; filep AND j < cnt; j++)
		filep = filep->next;
	    }
	pr_char('\n');
	if (++n == term_h - 3) {
	    dump();
	    if ((n = more(MORE, NULL, n, path, 0)) < 0)
		goto quit;
	    }
	lines++;
	}
finished:
    n = 0;
quit:
    /* T|m listan */
    while (filelist) {
	filep = filelist->next;
	free(filelist->name);
	free((char *) filelist);
	filelist = filep;
	}
    flush();
    dump();
    close(fd);
    return (n);
}

/*** Skriv "--More--" och se vad anv{ndaren vill g|ra ***/
more(m, str, n, name, line)
register int n, m, line;
register char *str, *name;
{
    char format[10];

    sprintf(format, "\r%%%ds\r", term_w);
    printf("%s", so);
    text(m, str);
    printf("%s", se);
again:
    switch (getupper()) {
	case ' ':
	    n = 0;
	    break;
	case '\n':
	    n--;
	    break;
	case 'Q':
	    n = QUIT;
	    break;
	case 'N':
	    n = NEXT;
	    break;
	case 'B':
	case 'O':
	    n = BINARY;
	    break;
	case '?':
	case 'H':
	    goto again;
	case 'F':
	    if (name) {
		printf(format, name);
		if (line)
		    printf(" %d", line);
		}
	    goto again;
	case '=':
	    if (line) {
		printf(format, "");
		printf("%d", line);
		}
	default:
	    goto again;
	}
    printf(format, "");
    return(n);
}

static unsigned char inbuf[512], *inbufp = inbuf;
static int n_read=0;
static char outbuf[512], *outbufp = outbuf;

/*** Rensa inbufferten ***/
flush()
{
    inbufp = inbuf;
    n_read = 0;
}

/*** L{s ett tecken fr}n fil ***/
read_char(fd)
register int fd;
{
    if (inbufp - inbuf == n_read) {
	inbufp = inbuf;
	if ((n_read = read(fd, inbuf, 512)) <= 0) {
	    n_read = 0;
	    return(ERROR);
	    }
	}
    return(*inbufp++);
}

/*** L{s len tecken fr}n en fil ***/
read_str(fd, str, len)
register int fd, len;
register char *str;
{
    register int n, c;

    for (n = 0; n < len; n++)
	if ((c = read_char(fd)) == ERROR)
	    break;
	else
	    *str++ = c;
    return (n);
}

/*** Skriv ut bufferten ***/
dump()
{
    write(STDOUT, outbuf, outbufp - outbuf);
    outbufp = outbuf;
}

/*** Skriv ett tecken i bufferten ***/
pr_char(c)
register char c;
{
    *outbufp++ = c;
    if (outbufp - outbuf == 512)
	dump();
}

/*** Skriv en str{ng i bufferten ***/
pr_str(s, len)
register char *s;
register int len;
{
    if (outbufp - outbuf + len >= 511)
	dump();
    while (len--)
	*outbufp++ = *s++;
}

