/*************************************************************************
    fsadm - File system administrator.
    1.00 85-09-16 Henrik Norbeck, Luxor Datorer AB
    kompileras med: make
   
    text.c	inneh}ller de spr}kberoende delarna, dvs arrayer med
		texter, samt funktionen strtime();
*************************************************************************/

#include <stdio.h>
#include <sys/types.h>
#include <time.h>
#include "fsadm.h"
#include "struct.h"

extern int lang;

int n_lang=2;

char *languages[] = {
    "english",
    "swedish"
    };

char *messages[] = {
    "Hit CE",				/* 0 HIT_CE */
    "Tryck CE",
    "Can't read directory",		/* 1 CANT_READ_DIR */
    "Kan ej l{sa biblioteket",
    "Can't get status for %s",		/* 2 NO_STATUS */
    "Kan ej l{sa status f|r %s",
    "Can't change to directory %s",	/* 3 CANT_CD */
    "Kan ej byta till biblioteket %s",
    "Can't read file %s\n\n",		/* 4 UNREADABLE */
    "Kan ej l{sa filen %s\n\n",
    "Next file: %s ",			/* 5 NEXT_FILE */
    "N{sta fil: %s ",
    "--More--",				/* 6 MORE */
    "--Mer--",
    "%s (directory):\n",		/* 7 DIRECTORY */
    "%s (bibliotek):\n",
    "%s is not a text file.\nDo you want to see it in octal? (y/n) ",
					/* 8 NOT_TEXT */
    "%s {r ej en textfil.\nVill du se den oktalt? (j/n) ",
    "Can't start a child process.",	/* 9 CANT_FORK */
    "Kan ej starta en dotterprocess.",
    "Can't remove file %s",		/* 10 CANT_RM */
    "Kan ej ta bort filen %s",
    "Can't remove directory %s",	/* 11 CANT_RMDIR */
    "Kan ej ta bort biblioteket %s",
    "Pattern: ",			/* 12 PATTERN */
    "M|nster: ",
    "Name of directory: ",		/* 13 DIRNAME */
    "Bibliotekets namn: ",
    "Can't create directory %s",	/* 14 NO_MKDIR */
    "Kan ej skapa biblioteket %s",
    "Link %s to: ",			/* 15 LINKNAME */
    "L{nk %s till: ",
    "Can't link to %s",			/* 16 CANT_LINK */
    "Kan ej l{nka till %s",
    "%s is a directory.",		/* 17 ISDIR */
    "%s {r ett bibliotek.",
    "Inode DU  G  O    # Owner    Group        Size Date    Time Name",
					/* 18 STAT_HEADER */
    " Inod B[  G  \\    # [gare    Grupp     Storlek Datum    Tid Namn"
    };

char *errors[] = {
    "",
    "",
    "TERM not found",
    "Kan ej finna TERM",
    "No terminal parameters found",
    "Inga terminal parametrar funna",
    "Terminal has too few columns or rows",
    "Terminalen har f|r f} rader/kolumner",
    "Can't create icon",
    "Kan ej skapa ikon",
    "Out of memory",
    "Minnet slut"
    };

char *months[] = {	/* Alla dessa str{ngar b|r vara lika l}nga,	*/
			/* }tminstone inom samma spr}k.			*/
			/* De svenska m}nadsnamnen skall b|rja med	*/
			/* mellanslag, eller se ut som "/1"		*/
    "Jan", " jan", "Feb", " feb", "Mar", " mar", "Apr", " apr",
    "May", " maj", "Jun", " jun", "Jul", " jul", "Aug", " aug",
    "Sep", " sep", "Oct", " oct", "Nov", " nov", "Dec", " dec"
    };

char *portheader[]={
    " Files ",
    " Filer ",
    " Directories ",
    " Bibliotek ",
    " Pool ",
    " Pool "
    };

int do_more(), do_cp(), do_mv(), do_rm(), do_ln(),
    do_mkdir(), do_chmod(), do_tarx(), do_tarc();

#define NCOMMANDS 9		/* number of command boxes */
#define NFUNCTIONS 4		/* number of function boxes */
int ncommands = NCOMMANDS;
int nfunctions = NFUNCTIONS;

struct click_box kikon[NCOMMANDS] = {
    {"tar x", do_tarx, FALSE},
    {"tar c", do_tarc, TRUE},
    {"chmod", do_chmod, TRUE},
    {"mkdir", do_mkdir, FALSE},
    {"link", do_ln, TRUE},
    {"remove", do_rm, TRUE},
    {"move", do_mv, TRUE},
    {"copy", do_cp, TRUE},
    {"more", do_more, TRUE},
};

int set_chdir(), set_mark(), goodbye(), choice();

struct click_box fikon[NFUNCTIONS] = {
    {">>", set_mark},
    {"chdir", set_chdir},
    {"choice", choice},
    {"exit", goodbye}
};

/*** G|r om ett datum av typ time_t till en str{ng ***/
char *timestr(t)
time_t t;
{
    struct tm *localtime();
    time_t *time();
    time_t *now;
    int this_year;
    register struct tm *lt;
    register char *mon;
    static char buf[26];

    now = time(0);
    lt = localtime(&now);
    this_year = lt->tm_year;
    lt = localtime(&t);
    mon = months[n_lang * lt->tm_mon + lang];
    if (lang == 1)	/* Svenska */
	if (this_year == lt->tm_year)
	    sprintf(buf, "%2d%s %2d:%c%c", lt->tm_mday, mon, lt->tm_hour,
			'0' + lt->tm_min / 10, '0' + lt->tm_min % 10);
	else
	    sprintf(buf, "%2d%s  19%c%c", lt->tm_mday, mon,
			'0' + lt->tm_year / 10, '0' + lt->tm_year % 10);
    else		/* Engelska */
	if (this_year == lt->tm_year)
	    sprintf(buf, "%s%3d %2d:%c%c", mon, lt->tm_mday, lt->tm_hour,
			'0' + lt->tm_min / 10, '0' + lt->tm_min % 10);
	else
	    sprintf(buf, "%s%3d  19%c%c", mon, lt->tm_mday,
			'0' + lt->tm_year / 10, '0' + lt->tm_year % 10);
    return (buf);
}
