/***********************************************************
	msh - menu shell interpreter

	0.00 85-08-15 ldab/fl: first version.
	1.00 85-10-14 ldab/hn: Can handle more than one menu
	2.00 85-11-28 ldab/hn: It's a shell now
	by Henrik Norbeck, Luxor Datorer AB 

	msh.h contains definitions of constants
***********************************************************/

/* Standard definitions */
#define  OFF	0
#define	 ON	1

#define	 TRUE 	1
#define	 FALSE  0
#define  NOT	!
#define  ERROR	-1
#define  NOTNULL (~NULL)

#define  STDIN	0
#define  STDOUT 1
#define  STDERR 2

#define  WAIT	 TRUE
#define  NO_WAIT FALSE

/* Names of the structure files */
#define  MENUFILE "/.abcesam"
#define  GRPDIR   "/usr/etc/xlabcesam/grp/"
#define  OTHDIR   "/usr/etc/xlabcesam"

#define  CATALOGUE "/usr/etc/xlabcesam/catalogue"

/* Input file field definitions */
#define  CAT_SYMB	0	/* objects in file structures */
#define  CAT_FLAG	1
#define	 CAT_TEXT	2
#define	 CAT_PROG	3
#define  CAT_INFO	4

#define  STR_NAME	0
#define  STR_SYMB	1
#define  STR_TEXT	2
#define  STR_PROG	3

#define  MENUSIZE	20
#define  MENULINE	64 /* Maximum size of a menu line */
#define	 PROGLINE	64 /* Maximum size of a program name */
#define  NAMELINE	20 /* Maximum size of a short name */
#define  STACKSIZE	10 /* Size of the menu stack */

#define  MARK	"->"			/* pointer on current menu line */
#define  NOMARK	"  "
#define  EXIT   "!"			/* code to exit from menu */

#define  CTRL_P	'\020'
#define  CTRL_N	'\016'
#define  CTRL_D '\004'
#define  CTRL_L '\014'

#define  BUFOUT 2048	/* output buffer */
#define	 MARKCHAR	'\1'

#define  ResBit(V,A)	(V &= ~(A))	/* reset bit mask */
#define  SetBit(V,A)	(V |= A)	/* set bit mask */

/* Messages: */
#define BAD_CMD 1
#define NO_PS	2
#define ERROR_FROM	3
#define PS_NR	4

struct var {
	char *name;
	char *value;
	struct var *next;
	};

